<?php

header('Content-type: text/html; charset=UTF-8');
setlocale(LC_CTYPE, 'fr_FR.UTF-8');

/* PHPDICO -----------------------------------------------------------------------------------------------------
	 ____    __  __  ____    ____    ______   ____     _____      
	/\  _`\ /\ \/\ \/\  _`\ /\  _`\ /\__  _\ /\  _`\  /\  __`\    
	\ \ \L\ \ \ \_\ \ \ \L\ \ \ \/\ \/_/\ \/ \ \ \/\_\\ \ \/\ \   
	 \ \ ,__/\ \  _  \ \ ,__/\ \ \ \ \ \ \ \  \ \ \/_/_\ \ \ \ \  
	  \ \ \/  \ \ \ \ \ \ \/  \ \ \_\ \ \_\ \__\ \ \L\ \\ \ \_\ \ 
	   \ \_\   \ \_\ \_\ \_\   \ \____/ /\_____\\ \____/ \ \_____\
		\/_/    \/_/\/_/\/_/    \/___/  \/_____/ \/___/   \/_____/
																  
	Dictionnaire PHP pour CFDICT, CC-CEDICT & HandeDict
			
	- VERSION 	: 2.2 (octobre 2017)
	- AUTEUR 	: David Houstin - david.houstin@gmail.com
	- SOURCE 	: https://chine.in
	- LICENCE 	: http://creativecommons.org/licenses/by-sa/3.0/
	- NOTICE 	: ce programme est fourni "tel quel" et vous êtes seul
				  responsable de son utilisation et des dommages qui pourraient en découler.
				
	ATTENTION : 
	1/ CE PROGRAMME NECESSITE LA FONCTION ICONV SUR LE SERVEUR
	2/ CE PROGRAMME NECESSITE UN FICHIER DE DEFINITION .U8 A TELECHARGER :
	- CFDICT (français) 	: https://chine.in/mandarin/dictionnaire/CFDICT/
	- CEDICT (anglais) 		: http://www.mdbg.net/chindict/chindict.php?page=cc-cedict
	- HANDEDICT (allemand) 	: http://www.chinaboard.de/chinesisch_deutsch.php?mode=dl

/* VARIABLES ---------------------------------------------------------------------------------------------------*/
	
	// le fichier-dictionnaire (cfdict.u8, cedict_ts.u8, handedict.u8)
	$dict = "cfdict.u8"; 
	
	// initialisation générale
	$counter = 0;
	
	$q = trim(stripslashes($_REQUEST["q"]));
	$q2 = hoteAccents($q);
	$q_HTML = mb_convert_encoding($q, 'HTML-ENTITIES', 'UTF-8');
	$q_nbcar = strlen($q2);

/* FONCTIONS ---------------------------------------------------------------------------------------------------*/

	// enlever les accents
	function hoteAccents($value)
	{
		return trim(strtolower(iconv('UTF-8', 'ASCII//TRANSLIT//IGNORE', $value)));
	}

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Dictionnaire chinois (PHP pour CFDICT, CEDICT, HanDeDict,...) - PHPDico</title>
<style>
	html {font-family:Arial, Helvetica, sans-serif;}
	form {display:block;margin-top:30px;margin-bottom:30px;border-top:1px dotted #CCC;border-bottom:1px dotted #CCC}
	form div {padding:10px}
	h1{margin-bottom:0px;padding-bottom:0px;font-size:20px}
	small {padding-top:3px;border-top:1px solid #222}
	#error {font-weight:bold;color:red;}
	.traduction {clear:both;width:100%;margin-top:5px;margin-bottom:5px;border-bottom:1px solid #CCC}
	.traduction span {display:block;padding:10px}
	.big5 {margin-left:10px;color:#757575}
	.cn {display:block;font-size:36px;font-family:Simsun}
	.cn div {display:inline}
	.py {display:block;font-size:12px;color:#999; letter-spacing:2px}
	.trans {display:block;font-size:14px;color:#222; margin-top:10px}
	.point {display:none}
</style>
</head>
<body>

<img src="https://chine.in/mandarin/dictionnaire/CFDICT/images/pdict.png" alt="PHPDICT" />

<form action="" method="GET"><div>
<strong>Mot clé</strong>:
<input name="q" type="text" id="q" value="<? echo $q; ?>" size="40">
<input type="submit" name="Submit" value="Chercher">
</div></form>

<p>
<h1>PHPDico : Dictionnaire chinois</h1>
Script libre en PHP lisant les fichiers .u8 des dictionnaires CFDICT, CEDICT,
HanDeDict, etc. <a href="https://chine.in/mandarin/dictionnaire/CFDICT/cfdict_php.zip">Télecharger PHPDico ici</a> (v2.2) 
</p> 

<div id="resultats">
<?php
	
/* RECHERCHE --------------------------------------------------------------------------------------------------*/
	
	if (isset($q) && strlen($q_HTML) > 2 && file_exists($dict))
	{
		// LECTURE DU FICHIER
		$lines = file($dict);
		
		foreach ($lines as $line)
		{
			$point = 0;
			$py = '';
			
			if ((stristr(hoteAccents($line),$q2) || stristr($q2,hoteAccents($line))) && !stristr($line,'#'))
			{
			
/* CREATION DES VARIABLES -------------------------------------------------------------------------------------*/

				$tab = explode ("] /",$line);
				$tab1 = explode (" ",$tab[0]); $nb1 = count ($tab1);
				
				// chinois traditionnel		
				$big5 = $tab1[0]; 
				
				// chinois simplifié
				$gb = $tab1[1]; 
				
				// traduction (français, anglais, allemand, etc. selon le fichier .u8)
				$trans = substr(trim(str_replace ("/", " / ", substr($tab[1],0,-2))),0,-1);
				$trans2 = hoteAccents($trans);

				// pinyin
				for ($j = 2; $j!= $nb1; $j++) $py .= str_replace('[','',$tab1[$j]). " ";
				$py = trim ($py); // pinyin
				
/* CALCUL DES "POINTS"-----------------------------------------------------------------------------------------*/

				// 1. par mot clé trouvé
				if (substr($q_HTML,0,2) != "&#") // si c'est pas du chinois
				{
					if ($q2 == $trans2
						|| stristr($trans2," / ".$q2." / ")
						|| (substr($trans2,0,$q_nbcar) == $q2 && stristr($trans2,$q2." / "))
						|| (substr($trans2,-$q_nbcar) == $q2 && stristr($trans2," / ".$q2))
						) 
					{
						$point = 100;
					}
					else
					{
						$tab_q = explode (' ',$q2);
						foreach ($tab_q as $mc)
						{
							if (stristr($mc," ".$trans2." ")) $point += 15;
							elseif (stristr($trans2," ".$mc." ")) $point += 20;
							elseif (stristr($mc,$trans2." ") || stristr($mc," ".$trans2)) $point += 5;
							elseif (stristr($trans2,$mc." ") || stristr($trans2," ".$mc)) $point += 10;
						}
					}
				}
				
				// 2. par nombre de caractères chinois si un seul mot recherché
				if (!strstr($q2, ' '))
				{
					$nb_car = strlen(mb_convert_encoding($gb, 'HTML-ENTITIES', 'UTF-8'))/8;
					
					if ($nb_car == 1) $point += 10;
					elseif ($nb_car == 2) $point += 5;
					elseif ($nb_car == 3) $point += 2;
					elseif ($nb_car == 4) $point += 1;
				}
				
/* AFFICHAGE DES RESULTATS ------------------------------------------------------------------------------------*/

				echo "<div class=\"element traduction\"><span>";
				echo "<div class=point>".$point."</div>"; // ATTENTION : ne pas enlever ou modifier cette ligne
				echo "<div class=cn><div lang='zh-cn' class=gb>".$gb."</div><div lang='zh-tw' class=big5>".$big5."</div></div>";
				echo "<div lang='zh-py' class=py>".$py."</div>";
				echo "<div class=trans>".$trans."</div>";
				echo "</span></div>";
				
				$counter++;
			}
		}
		if (empty($counter)) echo '<div id=error>DESOLE : aucun résultat trouvé pour cette requète.</div>';
	}
	elseif (!empty($q)) echo '<div id=error>ERREUR : veuillez entrer un mot plus long.</div>';
	elseif(!file_exists($dict)) echo 'ERREUR : problème d\'accès au fichier...';
?>
</div>

<!-- SOURCE : MERCI DE LAISSER AU MOINS UN LIEN VERS http://chine.in //-->
<p style="margin-top:40px;"><small>Sources : Ce programme libre venant de <a href="https://chine.in" title="Chine, chinois & Asie" target="_blank">Chine
Informations</a> fonctionne avec <a href="https://chine.in/mandarin/dictionnaire/CFDICT/" title="dictionnaire chinois libre" target="_blank">CFDICT</a>.</small></p>

<!-- JAVASCRIPT POUR ORDONNER / CLASSER LES RESULTATS A L'AFFICHAGE //-->
<script src="https://ajax.googleapis.com/ajax/libs/jquery/1/jquery.min.js"></script>
<script src="jquery.isotope.js"></script>
<script>
var $container = $('#resultats');
$(function(){
	$container.isotope({
		itemSelector : '.element',
		sortBy : 'point',
		sortAscending : false,
		getSortData : {
			point : function( $elem ) {
				return parseInt( $elem.find('.point').text(), 10 );
			},
		}
	});
});
</script>
<!-- FIN DU CLASSEMENT DES REULTATS ------------------------------ //-->

</body>
</html>